/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import com.rjconsultores.ventaboletos.entidad.ProdRuta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.ProdRutaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Administrador
 */
@Controller("editarProdRutaController")
@Scope("prototype")
public class EditarProdRutaController extends MyGenericForwardComposer {

    @Autowired
    private ProdRutaService prodRutaService;
    @Autowired
    private RutaService rutaService;
    private List<Ruta> lsRutas;
    private MyListbox prodRutaList;
    private Combobox cmbRuta;
    private List<ProdRuta> lsProdRuta;
    private ProdRuta prodRuta;
    private static Logger log = Logger.getLogger(EditarProdPuntoVentaController.class);

    public List<Ruta> getLsRutas() {
        return lsRutas;
    }

    public void setLsRutas(List<Ruta> lsRutas) {
        this.lsRutas = lsRutas;
    }

    public ProdRuta getProdRuta() {
        return prodRuta;
    }

    public void setProdRuta(ProdRuta prodRuta) {
        this.prodRuta = prodRuta;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsRutas = rutaService.obtenerTodos();
        lsProdRuta = (List<ProdRuta>) Executions.getCurrent().getArg().get("lsProdRuta");
        prodRuta = (ProdRuta) Executions.getCurrent().getArg().get("prodRuta");
        prodRutaList = (MyListbox) Executions.getCurrent().getArg().get("prodRutaList");

        super.doAfterCompose(comp);
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {
        cmbRuta.getValue();
        try {
            if (prodRuta.getRuta() == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Error.combobox"),
                        Labels.getLabel("editarProdRutaController.winEditarProdRuta.title"),
                        Messagebox.OK, Messagebox.ERROR);
                return;
            }

            if (prodRuta.getProdrutaId() != null) {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdRutaController.winEditarProdRuta.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodRutaService.actualizacion(prodRuta);
                prodRutaList.updateItem(prodRuta);
                lsProdRuta.add(prodRuta);
            } else {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdRutaController.winEditarProdRuta.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodRutaService.suscribir(prodRuta);
                prodRutaList.addItem(prodRuta);
                lsProdRuta.add(prodRuta);
            }

            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    private boolean registroDuplicado() throws InterruptedException {
        for (ProdRuta p : lsProdRuta) {
            if (!p.getActivo()){
                continue;
            }
            if (p.getRuta().getDescruta().equals(prodRuta.getRuta().getDescruta())) {
                return true;
            }
        }
        return false;
    }

    public void onClick$btnRemover(Event ev) {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdRutaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProdRutaController.winEditarProdRuta.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodRuta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodRuta.setFecmodif(Calendar.getInstance().getTime());
                prodRuta.setActivo(Boolean.FALSE);

                prodRutaList.removeItem(prodRuta);
                prodRutaService.borrar(prodRuta);

                Messagebox.show(
                        Labels.getLabel("editarProdRutaController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProdRutaController.winEditarProdRuta.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    /**
     * @return the lsProdRuta
     */
    public List<ProdRuta> getLsProdRuta() {
        return lsProdRuta;
    }

    /**
     * @param lsProdRuta the lsProdRuta to set
     */
    public void setLsProdRuta(List<ProdRuta> lsProdRuta) {
        this.lsProdRuta = lsProdRuta;
    }
}
